#ifndef GAME_HPP
#define GAME_HPP

#include <PA9.h>
#include <maxmod9.h>
#include "soundbank_bin.h"
#include "soundbank.h"
#include "all_gfx.h"

class Game{
	public :
	Game();
	void initSound();
	void initGraphics();
	void initAtt();
	void initGrid();
	void play();
	void brightnessUp();
	void brightnessDown();
	void setBoatPlayer();
	void setBoatComputer();
	void playerShot();
	void computerShot();
	bool win();
	void displayWin();
	bool loose();
	void displayLoose();
	bool quit();
	void pause(s32 time);
	void debugText();
	
	private :
	s32 x;
	s32 y;
	s32 xBase;
	s32 yBase;
	s32 xMax;
	s32 yMax;
	s32 xLastPlayer;
	s32 yLastPlayer;
	s32 StylusXInstant;
	s32 StylusYInstant;
	s32 nbrBoatPlayer;
	s32 nbrBoatComputer;
	s32 nbrSprite;
	s32 nbrSpriteComputer;
	s32 nbrShotSuccess;
	s32 nbrShotSuccessComputer;
	s32 torpilleurSink;
	s32 sousMarinSink;
	s32 contreTorpilleurSink;
	s32 croiseurSink;
	s32 porteAvionsSink;
	s32 torpilleurSinkComp;
	s32 sousMarinSinkComp;
	s32 contreTorpilleurSinkComp;
	s32 croiseurSinkComp;
	s32 porteAvionsSinkComp;
	bool HV;
	bool HVLast;
	bool rotate;
	bool empty;
	bool returnSetBoat;
	bool battleGridShotPlayer[10][10];
	s32 battleGridBoatPlayer[10][10];
	bool battleGridShotComputer[10][10];
	s32 battleGridBoatComputer[10][10];
};

#endif
