#include "Game.hpp"

Game::Game(){
	PA_InitRand();
	initAtt();
	initGrid();
	initGraphics();
	initSound();
	brightnessUp();
	setBoatComputer();
	setBoatPlayer();
}

void Game::initAtt(){
	xBase = 57;
	xMax = 0;
	xLastPlayer = 0;
	StylusXInstant = 0;
	x = xBase;
	yBase = 25;
	yMax = 0;
	yLastPlayer = 0;
	StylusYInstant = 0;
	y = yBase;
/*
0 -> torpilleur
1 -> sous_marin
2 -> contre_torpilleur
3 -> croiseur
4 -> porte_avions
*/
	nbrBoatPlayer = 0;
	nbrBoatComputer = 0;
	nbrSprite = 1;
	nbrSpriteComputer = 6;
	// 0 -> Horizontal | 1 -> Vertical
	HV = false;
	HVLast = false;
	rotate = false;
	empty = false;
	returnSetBoat = false;
	nbrShotSuccess = 0;
	nbrShotSuccessComputer = 0;
	torpilleurSink = 2;
	sousMarinSink = 3;
	contreTorpilleurSink = 3;
	croiseurSink = 4;
	porteAvionsSink = 5;
	torpilleurSinkComp = 2;
	sousMarinSinkComp = 3;
	contreTorpilleurSinkComp = 3;
	croiseurSinkComp = 4;
	porteAvionsSinkComp = 5;
}

void Game::initGrid(){
	for (int i(0) ; i < 10 ; i++){
		for (int j(0) ; j < 10 ; j++){
			battleGridShotPlayer[i][j] = false;
			battleGridBoatPlayer[i][j] = 0;
			battleGridShotComputer[i][j] = false;
			battleGridBoatComputer[i][j] = 0;
		}
	}
}

void Game::initGraphics(){
	PA_LoadBackground(1,3,&background);
	PA_LoadBackground(0,3,&background);	
	PA_LoadSpritePal(1,0,(void*)pal0_Pal);
	PA_LoadSpritePal(0,0,(void*)pal0_Pal);
	PA_LoadDefaultText(1,0);
	PA_LoadDefaultText(0,0);
	PA_CreateSprite(1,nbrBoatPlayer,(void*)H_torpilleur_Sprite,OBJ_SIZE_32X16,1,0,xBase,yBase);
}

void Game::initSound(){
	mmInitDefaultMem((mm_addr)soundbank_bin);
	mmLoad(MOD_MAIN_MUSIC);
	mmLoad(MOD_WIN_MUSIC);
	mmLoad(MOD_LOSE_MUSIC);
	mmLoadEffect(SFX_CANNON);
	mmLoadEffect(SFX_PLOUF);
	mmLoadEffect(SFX_EXPLODE);
	mmLoadEffect(SFX_WIN);
	mmLoadEffect(SFX_LOSE);
	mmStart(MOD_MAIN_MUSIC, MM_PLAY_LOOP);
}

void Game::play(){
	playerShot();
	quit();	
}

void Game::setBoatComputer(){
	s32 xMaxComp(0), yMaxComp(0);
	s32 xRand(0), yRand(0);
	// 0 -> Horizontal | 1 -> Vertical
	bool HVComp(false);
	bool emptyComp(false);
	while (nbrBoatComputer < 5){
		HVComp = PA_RandMax(1);
		if (!HVComp){
			yMaxComp = 9;
			if (nbrBoatComputer == 0) xMaxComp = 8;
			else if (nbrBoatComputer == 1 || nbrBoatComputer == 2) xMaxComp = 7;
			else if (nbrBoatComputer == 3) xMaxComp = 6;
			else if (nbrBoatComputer == 4) xMaxComp = 5;
			xRand = PA_RandMax(xMaxComp);
			yRand = PA_RandMax(yMaxComp);
			if (battleGridBoatComputer[yRand][xRand] == 0
				&& battleGridBoatComputer[yRand][xRand+1] == 0){
				if (nbrBoatComputer == 0) emptyComp = true;
				else if ((nbrBoatComputer == 1  || nbrBoatComputer == 2)&& battleGridBoatComputer[yRand][xRand+2] == 0) emptyComp = true;
				else if (nbrBoatComputer == 3 && battleGridBoatComputer[yRand][xRand+2] == 0 
											  && battleGridBoatComputer[yRand][xRand+3] == 0) emptyComp = true;
				else if (nbrBoatComputer == 4 && battleGridBoatComputer[yRand][xRand+2] == 0 
											  && battleGridBoatComputer[yRand][xRand+3] == 0
											  && battleGridBoatComputer[yRand][xRand+4] == 0) emptyComp = true;
				else emptyComp = false;
			}
			else emptyComp = false;
			if (emptyComp){
					battleGridBoatComputer[yRand][xRand] = nbrBoatComputer+1;
					battleGridBoatComputer[yRand][xRand+1] = nbrBoatComputer+1;			
					if (nbrBoatComputer >= 1 || nbrBoatComputer >= 2) battleGridBoatComputer[yRand][xRand+2] = nbrBoatComputer+1;
					if (nbrBoatComputer >= 3) battleGridBoatComputer[yRand][xRand+3] = nbrBoatComputer+1;
					if (nbrBoatComputer >= 4) battleGridBoatComputer[yRand][xRand+4] = nbrBoatComputer+1;
					nbrBoatComputer++;
			}
		}
		else{
			xMaxComp = 9;
			if (nbrBoatComputer == 0) yMaxComp = 8;
			else if (nbrBoatComputer == 1 || nbrBoatComputer == 2) yMaxComp = 7;
			else if (nbrBoatComputer == 3) yMaxComp = 6;
			else if (nbrBoatComputer == 4) yMaxComp = 5;
			xRand = PA_RandMax(xMaxComp);
			yRand = PA_RandMax(yMaxComp);
			if (battleGridBoatComputer[yRand][xRand] == 0
				&& battleGridBoatComputer[yRand+1][xRand] == 0){
				if (nbrBoatComputer == 0) emptyComp = true;
				else if ((nbrBoatComputer == 1  || nbrBoatComputer == 2)&& battleGridBoatComputer[yRand+2][xRand] == 0) emptyComp = true;
				else if (nbrBoatComputer == 3 && battleGridBoatComputer[yRand+2][xRand] == 0 
											  && battleGridBoatComputer[yRand+3][xRand] == 0) emptyComp = true;
				else if (nbrBoatComputer == 4 && battleGridBoatComputer[yRand+2][xRand] == 0 
											  && battleGridBoatComputer[yRand+3][xRand] == 0
											  && battleGridBoatComputer[yRand+4][xRand] == 0) emptyComp = true;
				else emptyComp = false;
			}
			else emptyComp = false;
			if (emptyComp){
					battleGridBoatComputer[yRand][xRand] = nbrBoatComputer+1;
					battleGridBoatComputer[yRand+1][xRand] = nbrBoatComputer+1;			
					if (nbrBoatComputer >= 1 || nbrBoatComputer >= 2) battleGridBoatComputer[yRand+2][xRand] = nbrBoatComputer+1;
					if (nbrBoatComputer >= 3) battleGridBoatComputer[yRand+3][xRand] = nbrBoatComputer+1;
					if (nbrBoatComputer >= 4) battleGridBoatComputer[yRand+4][xRand] = nbrBoatComputer+1;
					nbrBoatComputer++;
			}
		}
	}
}

void Game::setBoatPlayer(){
	PA_OutputSimpleText(0,2,0,"First, place your five boats");
	while (nbrBoatPlayer < 5){
		if (Pad.Newpress.B && nbrBoatPlayer && returnSetBoat){
			x = xBase;
			y = yBase;
			PA_DeleteSprite(1,nbrBoatPlayer);
			if (nbrBoatPlayer == 5) PA_DeleteSprite(1,nbrBoatPlayer+1);
			if (!HVLast){
				battleGridBoatPlayer[((yLastPlayer-8)>>4)-1][((xLastPlayer-40)>>4)-1] = 0;
				battleGridBoatPlayer[((yLastPlayer-8)>>4)-1][(xLastPlayer-40)>>4] = 0;			
				if (nbrBoatPlayer >= 1 || nbrBoatPlayer >= 2) battleGridBoatPlayer[((yLastPlayer-8)>>4)-1][((xLastPlayer-40)>>4)+1] = 0;
				if (nbrBoatPlayer >= 3) battleGridBoatPlayer[((yLastPlayer-8)>>4)-1][((xLastPlayer-40)>>4)+2] = 0;
				if (nbrBoatPlayer >= 4) battleGridBoatPlayer[((yLastPlayer-8)>>4)-1][((xLastPlayer-40)>>4)+3] = 0;
			}
			else{
				battleGridBoatPlayer[((yLastPlayer-8)>>4)-1][((xLastPlayer-40)>>4)-1] = 0;
				battleGridBoatPlayer[((yLastPlayer-8)>>4)][((xLastPlayer-40)>>4)-1] = 0;			
				if (nbrBoatPlayer >= 1 || nbrBoatPlayer >= 2) battleGridBoatPlayer[((yLastPlayer-8)>>4)+1][((xLastPlayer-40)>>4)-1] = 0;
				if (nbrBoatPlayer >= 3) battleGridBoatPlayer[((yLastPlayer-8)>>4)+2][((xLastPlayer-40)>>4)-1] = 0;
				if (nbrBoatPlayer >= 4) battleGridBoatPlayer[((yLastPlayer-8)>>4)+3][((xLastPlayer-40)>>4)-1] = 0;
			}
			nbrBoatPlayer--;
			returnSetBoat = false;
		}
		if (Pad.Newpress.R || Pad.Newpress.L){
			if (!HV){
				if (nbrBoatPlayer == 0 && y <= 153) rotate = true;
				else if ((nbrBoatPlayer == 1 || nbrBoatPlayer == 2) && y <= 137) rotate = true;
				else if (nbrBoatPlayer == 3 && y <= 121) rotate = true;
				else if (nbrBoatPlayer == 4 && y <= 105) rotate = true;
				else rotate = false;
			}
			else{
				if (nbrBoatPlayer == 0 && x <= 185) rotate = true;
				else if ((nbrBoatPlayer == 1 || nbrBoatPlayer == 2) && x <= 169) rotate = true;
				else if (nbrBoatPlayer == 3 && x <= 153) rotate = true;
				else if (nbrBoatPlayer == 4 && x <= 137) rotate = true;
				else rotate = false;
			}
			if (rotate){
				if (!HV){
					if (nbrBoatPlayer == 0) PA_CreateSprite(1,nbrBoatPlayer,(void*)V_torpilleur_Sprite,OBJ_SIZE_16X32,1,0,x,y);
					else if (nbrBoatPlayer == 1) PA_CreateSprite(1,nbrBoatPlayer,(void*)V_sous_marin_Sprite,OBJ_SIZE_32X64,1,0,x,y);
					else if (nbrBoatPlayer == 2) PA_CreateSprite(1,nbrBoatPlayer,
																(void*)V_contre_torpilleur_Sprite,OBJ_SIZE_32X64,1,0,x,y);
					else if (nbrBoatPlayer == 3) PA_CreateSprite(1,nbrBoatPlayer,(void*)V_croiseur_Sprite,OBJ_SIZE_32X64,1,0,x,y);
					else if (nbrBoatPlayer == 4){
						PA_CreateSprite(1,nbrBoatPlayer,(void*)V_porte_avions_2_Sprite,OBJ_SIZE_16X32,1,0,x,y);
						PA_CreateSprite(1,nbrBoatPlayer+1,(void*)V_porte_avions_1_Sprite,OBJ_SIZE_32X64,1,0,x,y+32);
					}
					HV = true;				
				}
				else{
					if (nbrBoatPlayer == 0) PA_CreateSprite(1,nbrBoatPlayer,(void*)H_torpilleur_Sprite,OBJ_SIZE_32X16,1,0,x,y);
					else if (nbrBoatPlayer == 1) PA_CreateSprite(1,nbrBoatPlayer,(void*)H_sous_marin_Sprite,OBJ_SIZE_64X32,1,0,x,y);
					else if (nbrBoatPlayer == 2) PA_CreateSprite(1,nbrBoatPlayer,
																(void*)H_contre_torpilleur_Sprite,OBJ_SIZE_64X32,1,0,x,y);
					else if (nbrBoatPlayer == 3) PA_CreateSprite(1,nbrBoatPlayer,(void*)H_croiseur_Sprite,OBJ_SIZE_64X32,1,0,x,y);
					else if (nbrBoatPlayer == 4){
						PA_CreateSprite(1,nbrBoatPlayer,(void*)H_porte_avions_1_Sprite,OBJ_SIZE_64X32,1,0,x,y);
						PA_CreateSprite(1,nbrBoatPlayer+1,(void*)H_porte_avions_2_Sprite,OBJ_SIZE_32X16,1,0,x+48,y);
					}
					HV = false;
				}
			}
		}
		if (!HV){
			yMax = 169;
			if (nbrBoatPlayer == 0) xMax = 185;
			if (nbrBoatPlayer == 1 || nbrBoatPlayer == 2) xMax = 169;
			else if (nbrBoatPlayer == 3) xMax = 153;
			else if (nbrBoatPlayer == 4) xMax = 137;
			if (Pad.Newpress.Up && y > yBase) y -= 16;
			if (Pad.Newpress.Down && y < yMax) y += 16;
			if (Pad.Newpress.Right && x < xMax) x += 16;
			if (Pad.Newpress.Left && x > xBase) x -= 16;
			PA_SetSpriteXY(1,nbrBoatPlayer,x,y);
			if (nbrBoatPlayer == 4) PA_SetSpriteXY(1,nbrBoatPlayer+1,x+48,y);
			if (Pad.Newpress.A){
				if (battleGridBoatPlayer[((y-8)>>4)-1][((x-40)>>4)-1] == 0
					&& battleGridBoatPlayer[((y-8)>>4)-1][(x-40)>>4] == 0){
					if (nbrBoatPlayer == 0) empty = true;
					else if ((nbrBoatPlayer == 1  || nbrBoatPlayer == 2) 
							  && battleGridBoatPlayer[((y-8)>>4)-1][((x-40)>>4)+1] == 0) empty = true;
					else if (nbrBoatPlayer == 3 && battleGridBoatPlayer[((y-8)>>4)-1][((x-40)>>4)+1] == 0
												&& battleGridBoatPlayer[((y-8)>>4)-1][((x-40)>>4)+2] == 0) empty = true;
					else if (nbrBoatPlayer == 4 && battleGridBoatPlayer[((y-8)>>4)-1][((x-40)>>4)+1] == 0
												&& battleGridBoatPlayer[((y-8)>>4)-1][((x-40)>>4)+2] == 0 
												&& battleGridBoatPlayer[((y-8)>>4)-1][((x-40)>>4)+3] == 0) empty = true;
					else empty = false;
				}
				else empty = false;
				if (empty){
					HVLast = false;
					returnSetBoat = true;
					xLastPlayer = x;
					yLastPlayer = y;
					battleGridBoatPlayer[((y-8)>>4)-1][((x-40)>>4)-1] = nbrBoatPlayer+1;
					battleGridBoatPlayer[((y-8)>>4)-1][(x-40)>>4] = nbrBoatPlayer+1;			
					if (nbrBoatPlayer >= 1 || nbrBoatPlayer >= 2) battleGridBoatPlayer[((y-8)>>4)-1][((x-40)>>4)+1] = nbrBoatPlayer+1;
					if (nbrBoatPlayer >= 3) battleGridBoatPlayer[((y-8)>>4)-1][((x-40)>>4)+2] = nbrBoatPlayer+1;
					if (nbrBoatPlayer >= 4) battleGridBoatPlayer[((y-8)>>4)-1][((x-40)>>4)+3] = nbrBoatPlayer+1;
					nbrBoatPlayer++;
					x = xBase;
					y = yBase;
					if (nbrBoatPlayer == 1) PA_CreateSprite(1,nbrBoatPlayer,(void*)H_sous_marin_Sprite,OBJ_SIZE_64X32,1,0,xBase,yBase);
					else if (nbrBoatPlayer == 2) PA_CreateSprite(1,nbrBoatPlayer,
																(void*)H_contre_torpilleur_Sprite,OBJ_SIZE_64X32,1,0,xBase,yBase);
					else if (nbrBoatPlayer == 3) PA_CreateSprite(1,nbrBoatPlayer,(void*)H_croiseur_Sprite,OBJ_SIZE_64X32,1,0,xBase,yBase);
					else if (nbrBoatPlayer == 4){
						PA_CreateSprite(1,nbrBoatPlayer,(void*)H_porte_avions_1_Sprite,OBJ_SIZE_64X32,1,0,xBase,yBase);
						PA_CreateSprite(1,nbrBoatPlayer+1,(void*)H_porte_avions_2_Sprite,OBJ_SIZE_32X16,1,0,xBase+48,yBase);
					}				
				}
			}
			PA_WaitForVBL();
		}
		else{
			xMax = 201;
			if (nbrBoatPlayer == 0) yMax = 153;
			else if (nbrBoatPlayer == 1 || nbrBoatPlayer == 2) yMax = 137;
			else if (nbrBoatPlayer == 3) yMax = 121;
			else if (nbrBoatPlayer == 4) yMax = 105;
			if (Pad.Newpress.Up && y > yBase) y -= 16;
			if (Pad.Newpress.Down && y < yMax) y += 16;
			if (Pad.Newpress.Right && x < xMax) x += 16;
			if (Pad.Newpress.Left && x > xBase) x -= 16;
			PA_SetSpriteXY(1,nbrBoatPlayer,x,y);
			if (nbrBoatPlayer == 4) PA_SetSpriteXY(1,nbrBoatPlayer+1,x,y+32);
			if (Pad.Newpress.A){
				if (battleGridBoatPlayer[((y-8)>>4)-1][((x-40)>>4)-1] == 0
					&& battleGridBoatPlayer[((y-8)>>4)][((x-40)>>4)-1] == 0){
					if (nbrBoatPlayer == 0) empty = true;
					else if ((nbrBoatPlayer == 1  || nbrBoatPlayer == 2) 
							  && battleGridBoatPlayer[((y-8)>>4)+1][((x-40)>>4)-1] == 0) empty = true;
					else if (nbrBoatPlayer == 3 && battleGridBoatPlayer[((y-8)>>4)+1][((x-40)>>4)-1] == 0
												&& battleGridBoatPlayer[((y-8)>>4)+2][((x-40)>>4)-1] == 0) empty = true;
					else if (nbrBoatPlayer == 4 && battleGridBoatPlayer[((y-8)>>4)+1][((x-40)>>4)-1] == 0
												&& battleGridBoatPlayer[((y-8)>>4)+2][((x-40)>>4)-1] == 0 
												&& battleGridBoatPlayer[((y-8)>>4)+3][((x-40)>>4)-1] == 0) empty = true;
					else empty = false;
				}
				else empty = false;
				if (empty){
					HVLast = true;
					returnSetBoat = true;
					xLastPlayer = x;
					yLastPlayer = y;
					battleGridBoatPlayer[((y-8)>>4)-1][((x-40)>>4)-1] = nbrBoatPlayer+1;
					battleGridBoatPlayer[((y-8)>>4)][((x-40)>>4)-1] = nbrBoatPlayer+1;			
					if (nbrBoatPlayer >= 1 || nbrBoatPlayer >= 2) battleGridBoatPlayer[((y-8)>>4)+1][((x-40)>>4)-1] = nbrBoatPlayer+1;
					if (nbrBoatPlayer >= 3) battleGridBoatPlayer[((y-8)>>4)+2][((x-40)>>4)-1] = nbrBoatPlayer+1;
					if (nbrBoatPlayer >= 4) battleGridBoatPlayer[((y-8)>>4)+3][((x-40)>>4)-1] = nbrBoatPlayer+1;
					nbrBoatPlayer++;
					x = xBase;
					y = yBase;
					if (nbrBoatPlayer == 1) PA_CreateSprite(1,nbrBoatPlayer,(void*)V_sous_marin_Sprite,OBJ_SIZE_32X64,1,0,xBase,yBase);
					else if (nbrBoatPlayer == 2) PA_CreateSprite(1,nbrBoatPlayer,
																(void*)V_contre_torpilleur_Sprite,OBJ_SIZE_32X64,1,0,xBase,yBase);
					else if (nbrBoatPlayer == 3) PA_CreateSprite(1,nbrBoatPlayer,(void*)V_croiseur_Sprite,OBJ_SIZE_32X64,1,0,xBase,yBase);
					else if (nbrBoatPlayer == 4){
						PA_CreateSprite(1,nbrBoatPlayer,(void*)V_porte_avions_2_Sprite,OBJ_SIZE_16X32,1,0,xBase,yBase);
						PA_CreateSprite(1,nbrBoatPlayer+1,(void*)V_porte_avions_1_Sprite,OBJ_SIZE_32X64,1,0,xBase,yBase+32);
					}				
				}
			}
			PA_WaitForVBL();
		}
	}
	PA_ClearTextBg(0);
	PA_SetTextTileCol(0,TEXT_RED);
	PA_OutputSimpleText(0,3,0,"Now shoot his freaky face !");
}

void Game::playerShot(){
	if (Stylus.X >= 56 && Stylus.X <= 214 && Stylus.Y >= 24  && Stylus.Y <= 182){
			if (Stylus.Released	&& !battleGridShotPlayer[((Stylus.Y-8)>>4)-1][((Stylus.X-40)>>4)-1]){
				StylusXInstant = Stylus.X;
				StylusYInstant = Stylus.Y;
				mmEffect(SFX_CANNON);
				PA_ClearTextBg(0);
				if (battleGridBoatComputer[((StylusYInstant-8)>>4)-1][((StylusXInstant-40)>>4)-1]){
					PA_CreateSprite(0,nbrSprite,(void*)success_Sprite,OBJ_SIZE_16X16,1,0,
									(((StylusXInstant-40)>>4)<<4)+41,(((StylusYInstant-8)>>4)<<4)+9);
					PA_SetTextTileCol(0,TEXT_RED);
					PA_OutputSimpleText(0,13,0,"Touch !");
					nbrShotSuccess++;
					switch (battleGridBoatComputer[((StylusYInstant-8)>>4)-1][((StylusXInstant-40)>>4)-1]){
						case 1 :
							torpilleurSinkComp--;
							if (!torpilleurSinkComp){
								PA_ClearTextBg(0);
								PA_SetTextTileCol(0,TEXT_BLUE);
								PA_OutputSimpleText(0,13,0,"Sink !");
							}
							break;
						case 2 :
							sousMarinSinkComp--;
							if (!sousMarinSinkComp){
								PA_ClearTextBg(0);
								PA_SetTextTileCol(0,TEXT_BLUE);
								PA_OutputSimpleText(0,13,0,"Sink !");
							}
							break;
						case 3 :
							contreTorpilleurSinkComp--;
							if (!contreTorpilleurSinkComp){
								PA_ClearTextBg(0);
								PA_SetTextTileCol(0,TEXT_BLUE);
								PA_OutputSimpleText(0,13,0,"Sink !");
							}
							break;
						case 4 :
							croiseurSinkComp--;
							if (!croiseurSinkComp){
								PA_ClearTextBg(0);
								PA_SetTextTileCol(0,TEXT_BLUE);
								PA_OutputSimpleText(0,13,0,"Sink !");
							}
							break;
						case 5 :
							porteAvionsSinkComp--;
							if (!porteAvionsSinkComp){
								PA_ClearTextBg(0);
								PA_SetTextTileCol(0,TEXT_BLUE);
								PA_OutputSimpleText(0,13,0,"Sink !");
							}
							break;
						default :
							break;
					}
					pause(20);
					mmEffect(SFX_EXPLODE);
				}
				else{
					PA_CreateSprite(0,nbrSprite,(void*)fail_Sprite,OBJ_SIZE_16X16,1,0,
									(((StylusXInstant-40)>>4)<<4)+41,(((StylusYInstant-8)>>4)<<4)+9);
					PA_SetTextTileCol(0,TEXT_WHITE);
					PA_OutputSimpleText(0,13,0,"Fail...");
					pause(20);
					mmEffect(SFX_PLOUF);
				}				
				nbrSprite++;
				battleGridShotPlayer[((StylusYInstant-8)>>4)-1][((StylusXInstant-40)>>4)-1] = true;
				pause(40);
				if (nbrShotSuccess != 17){	
					computerShot();
					pause(40);
				}
			}
	}
}

void Game::computerShot(){
	bool wright(false);
	s32 computerX(0);
	s32 computerY(0);
	while (!wright){
		computerX = PA_RandMax(9);
		computerY = PA_RandMax(9);
		if (!battleGridShotComputer[computerY][computerX]){
			mmEffect(SFX_CANNON);
			if (battleGridBoatPlayer[computerY][computerX]){
				PA_CreateSprite(1,nbrSpriteComputer,(void*)success_Sprite,OBJ_SIZE_16X16,1,0,
								((computerX+1)<<4)+41,((computerY+1)<<4)+9);
				PA_SetTextTileCol(1,TEXT_RED);
				PA_OutputSimpleText(1,13,0,"Touch !");
				nbrShotSuccessComputer++;
				switch (battleGridBoatPlayer[computerY][computerX]){
						case 1 :
							torpilleurSink--;
							if (!torpilleurSink){
								PA_ClearTextBg(1);
								PA_SetTextTileCol(1,TEXT_BLUE);
								PA_OutputSimpleText(1,13,0,"Sink !");
							}
							break;
						case 2 :
							sousMarinSink--;
							if (!sousMarinSink){
								PA_ClearTextBg(1);
								PA_SetTextTileCol(1,TEXT_BLUE);
								PA_OutputSimpleText(1,13,0,"Sink !");
							}
							break;
						case 3 :
							contreTorpilleurSink--;
							if (!contreTorpilleurSink){
								PA_ClearTextBg(1);
								PA_SetTextTileCol(1,TEXT_BLUE);
								PA_OutputSimpleText(1,13,0,"Sink !");
							}
							break;
						case 4 :
							croiseurSink--;
							if (!croiseurSink){
								PA_ClearTextBg(1);
								PA_SetTextTileCol(1,TEXT_BLUE);
								PA_OutputSimpleText(1,13,0,"Sink !");
							}
							break;
						case 5 :
							porteAvionsSink--;
							if (!porteAvionsSink){
								PA_ClearTextBg(1);
								PA_SetTextTileCol(1,TEXT_BLUE);
								PA_OutputSimpleText(1,13,0,"Sink !");
							}
							break;
						default :
							break;
					}
				pause(20);
				mmEffect(SFX_EXPLODE);
			}
			else{
				PA_CreateSprite(1,nbrSpriteComputer,(void*)fail_Sprite,OBJ_SIZE_16X16,1,0,
								((computerX+1)<<4)+41,((computerY+1)<<4)+9);
				PA_SetTextTileCol(1,TEXT_WHITE);
				PA_OutputSimpleText(1,13,0,"Fail...");
				pause(20);
				mmEffect(SFX_PLOUF);
			}
			nbrSpriteComputer++;
			battleGridShotComputer[computerY][computerX] = true;
			wright = true;
		}
	}
}

bool Game::win(){
	if (nbrShotSuccess == 17){
		displayWin();
		return 1;
	}
	else return 0;
}

void Game::displayWin(){
	PA_ClearTextBg(0);
	PA_SetTextTileCol(0,TEXT_GREEN);
	mmStop();
	PA_OutputSimpleText(0,12,0,"Winner !");
	PA_CreateSprite(0,nbrSprite+1,(void*)explosion_Sprite,OBJ_SIZE_16X16,1,0,PA_RandMinMax(56,200),PA_RandMinMax(24,168));
	for (s32 i(0) ; i < 30 ; i++){
		PA_SetSpriteXY(0,nbrSprite+1,PA_RandMinMax(56,200),PA_RandMinMax(24,168));
		mmEffect(SFX_EXPLODE);
		pause(10);
	}
	PA_DeleteSprite(0,nbrSprite+1);	
	pause(60);
	brightnessDown();
	mmEffect(SFX_WIN);
	mmStart(MOD_WIN_MUSIC, MM_PLAY_LOOP);
	PA_ResetSpriteSys();
	PA_ResetBgSys();
	PA_LoadBackground(1,3,&win_screen_1);
	PA_LoadBackground(0,3,&win_screen_2);
	brightnessUp();
	while (!(Pad.Newpress.A || Stylus.Newpress)) PA_WaitForVBL();
	brightnessDown();
	PA_ResetBgSys();
}

bool Game::loose(){
	if (nbrShotSuccessComputer == 17){
		displayLoose();
		return 1;
	}
	else return 0;
}

void Game::displayLoose(){
	PA_ClearTextBg(0);
	PA_SetTextTileCol(0,TEXT_GREEN);
	mmStop();
	PA_OutputSimpleText(0,11,0,"Looser...");
	PA_CreateSprite(1,nbrSpriteComputer+1,(void*)explosion_Sprite,OBJ_SIZE_16X16,1,0,PA_RandMinMax(56,200),PA_RandMinMax(24,168));
	for (s32 i(0) ; i < 30 ; i++){
		PA_SetSpriteXY(1,nbrSpriteComputer+1,PA_RandMinMax(56,200),PA_RandMinMax(24,168));
		mmEffect(SFX_EXPLODE);
		pause(10);
	}
	PA_DeleteSprite(1,nbrSpriteComputer+1);
	pause(60);	
	brightnessDown();
	mmEffect(SFX_LOSE);
	mmStart(MOD_LOSE_MUSIC, MM_PLAY_LOOP);
	PA_ResetSpriteSys();
	PA_ResetBgSys();
	PA_LoadBackground(1,3,&loose_screen_1);
	PA_LoadBackground(0,3,&loose_screen_2);
	brightnessUp();
	while (!(Pad.Newpress.A || Stylus.Newpress)) PA_WaitForVBL();
	brightnessDown();
	PA_ResetBgSys();
}

bool Game::quit(){
	if (Pad.Newpress.Start){
		brightnessDown();
		PA_ResetSpriteSys();
		PA_ResetBgSys();
		return true;
	}
	else return false;
}

void Game::pause(s32 time){
	while (time){
		time--;
		PA_WaitForVBL();
	}
}

void Game::brightnessUp(){
	for (s32 i = -31 ; i <= 0 ; i++){
		PA_SetBrightness(1,i);
		PA_SetBrightness(0,i);
		PA_WaitForVBL();
	}
}

void Game::brightnessDown(){
	for (s32 i = 0 ; i >= -31 ; i--){
		PA_SetBrightness(1,i);
		PA_SetBrightness(0,i);
		PA_WaitForVBL();
	}
}

void Game::debugText(){
	for (s32 i(0) ; i < 10 ; i++){
		for (s32 j(0) ; j < 10 ; j++){
			PA_OutputText(1,j,i,"%d",battleGridBoatPlayer[i][j]);
		}	
	}
}

