#include "Menu.hpp"

void Menu::init(){
	mmInitDefaultMem((mm_addr)soundbank_bin);	
	mmLoad(MOD_MENU_MUSIC);
	mmLoadEffect(SFX_BUBBLE);
	mmLoadEffect(SFX_SONAR);
	mmStart(MOD_MENU_MUSIC, MM_PLAY_LOOP);
	PA_LoadDefaultText(0,0);
	PA_LoadBackground(1,3,&title_screen1);
	PA_LoadBackground(0,3,&title_screen2);
	PA_LoadSpritePal(0,0,(void*)pal0_Pal);
	PA_CreateSprite(0,0,(void*)cursor_Sprite,OBJ_SIZE_16X16,1,0,66,29);
}

void Menu::unload(){
	PA_ResetBgSys();
	PA_ResetSpriteSys();
	mmStop();
	mmUnload(MOD_MENU_MUSIC);
	mmUnloadEffect(SFX_BUBBLE);
	mmUnloadEffect(SFX_SONAR);
}

void Menu::display(){
	// false = Play & true = Credits
	s32 choice(0);
	init();
	brightnessUp();	
	while (!((Pad.Newpress.A || Stylus.Released) && !choice)){
		if (Stylus.Held){
			if (Stylus.X > 80 && Stylus.X < 178
				&& Stylus.Y > 20 && Stylus.Y < 57){
				PA_SetSpriteXY(0,0,66,29);
				choice = 0;
			}
			else if (Stylus.X > 36 && Stylus.X < 221
					 && Stylus.Y > 61 && Stylus.Y < 88){
				PA_SetSpriteXY(0,0,21,66);
				choice = 1;
			}
			else if (Stylus.X > 49 && Stylus.X < 207
					 && Stylus.Y > 98 && Stylus.Y < 128){
				PA_SetSpriteXY(0,0,35,105);
				choice = 2;
			}
			else if (Stylus.X > 48 && Stylus.X < 207
					 && Stylus.Y > 135 && Stylus.Y < 166){
				PA_SetSpriteXY(0,0,34,142);
				choice = 3;
			}
		}
		if (Pad.Newpress.Up){
			if (choice == 1){
				PA_SetSpriteXY(0,0,66,29);
				choice = 0;
			}
			else if (choice == 2){
				PA_SetSpriteXY(0,0,21,66);
				choice = 1;
			}
			else if (choice == 3){
				PA_SetSpriteXY(0,0,35,105);
				choice = 2;
			}
			mmEffect(SFX_BUBBLE);
		}
		if (Pad.Newpress.Down){
			if (choice == 0){
				PA_SetSpriteXY(0,0,21,66);
				choice = 1;
			}
			else if (choice == 1){
				PA_SetSpriteXY(0,0,35,105);
				choice = 2;
			}
			else if (choice == 2){
				PA_SetSpriteXY(0,0,34,142);
				choice = 3;
			}
			mmEffect(SFX_BUBBLE);
		}
		if (Pad.Newpress.A || Stylus.Released){
			mmEffect(SFX_SONAR);
			if (choice == 1) controls();
			else if (choice == 2) manual();
			else if (choice == 3) credits();
			choice = 0;
		}
		PA_WaitForVBL();
	}
	mmEffect(SFX_SONAR);
	brightnessDown();
	unload();	
}

void Menu::credits(){
	brightnessDown();
	u32 nletters = (0);
	u32 letter = (0);
	PA_DeleteSprite(0,0);
	PA_DeleteBg(0,3);
	PA_LoadBackground(0,3,&blue_screen);
	brightnessUp();
	while (letter == nletters){
		++nletters;	
		letter = PA_BoxText(0,0,0,31,31,"%c1\n\n\n\n# Game coding by : Me\n\n# Graphics by : Me, except the boat on the title screen, and the tux on the splash\n\n# Sound by : The Mod Archive and FindSound\n\n# Create for : My lovely girl-friend\n\n# Made with PAlib and Maxmod\n\n\nThanks for playing !%c0",nletters);
		PA_WaitForVBL();
	}
	while (!(Pad.Newpress.B || Stylus.Released)) PA_WaitForVBL();
	brightnessDown();
	PA_ClearTextBg(0);
	PA_DeleteBg(0,3);
	PA_LoadBackground(0,3,&title_screen2);
	PA_CreateSprite(0,0,(void*)cursor_Sprite,OBJ_SIZE_16X16,1,0,66,29);
	brightnessUp();
}

void Menu::controls(){
	brightnessDown();
	u32 nletters = (0);
	u32 letter = (0);
	PA_DeleteSprite(0,0);
	PA_DeleteBg(0,3);
	PA_LoadBackground(0,3,&blue_screen);
	brightnessUp();
	while (letter == nletters){
		++nletters;	
		letter = PA_BoxText(0,0,0,31,31,"%c1\n# Press A to place your boat\n\n# Press X to rotate it\n\n# Press B to replace the last boat (experimental)\n\n# Press Start to quit the game and go to the menu\n\n# Touch the bottom screen to fire (only avaible when you had place all of your boat)\n\n# The first who has sink all of his rival's boats has win the game\n\n\nGood luck, and enjoy !%c0",nletters);
		PA_WaitForVBL();
	}
	while (!(Pad.Newpress.B || Stylus.Released)) PA_WaitForVBL();
	brightnessDown();
	PA_ClearTextBg(0);
	PA_DeleteBg(0,3);
	PA_LoadBackground(0,3,&title_screen2);
	PA_CreateSprite(0,0,(void*)cursor_Sprite,OBJ_SIZE_16X16,1,0,66,29);
	brightnessUp();
}

void Menu::manual(){
	brightnessDown();
	u32 nletters = (0);
	u32 letter = (0);
	PA_DeleteSprite(0,0);
	PA_DeleteBg(0,3);
	PA_LoadBackground(0,3,&blue_screen);
	brightnessUp();
	while (letter == nletters){
		++nletters;	
		letter = PA_BoxText(0,0,0,31,31,"%c1\nNot avaible for the moment\n\nI'm to lazy to write it immediately ;)%c0",nletters);
		PA_WaitForVBL();
	}
	while (!(Pad.Newpress.B || Stylus.Released)) PA_WaitForVBL();
	brightnessDown();
	PA_ClearTextBg(0);
	PA_DeleteBg(0,3);
	PA_LoadBackground(0,3,&title_screen2);
	PA_CreateSprite(0,0,(void*)cursor_Sprite,OBJ_SIZE_16X16,1,0,66,29);
	brightnessUp();
}

void Menu::brightnessDown(){
	for (s32 i = 0 ; i >= -31 ; i--){
		PA_SetBrightness(1,i);
		PA_SetBrightness(0,i);
		PA_WaitForVBL();
	}
}

void Menu::brightnessUp(){
	for (s32 i = -31 ; i<=0 ; i++){
		PA_SetBrightness(1,i);
		PA_SetBrightness(0,i);
		PA_WaitForVBL();
	}
}

